
//Von dieser Klasse werden die Klassen
//ParallelLine, PerpendicularLine, StraightLine,
//StraightLineMS,StraightLineSH und StraightLineWH
//abgeleitet
public class Line extends GeoObject {
  
  //Attribute
  protected boolean selected = false;
  protected boolean schnittmodus = false; 
  
  public Line(Point point1, Point point2) {
    this.point1 = point1;
    this.point2 = point2;
    point5 = point1;
    point6 = point2;
    point7 = new Point(-10,0); //unsichtbar, wenn nicht benutzt
    
  }
  //Die meisten der folgenden Methoden werden auch von
  //den abgeleiteten Klassen benutzt.
  public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point2);
     return abhaengig;  
  }
  
  public boolean getSelected() {
    return selected ;
  }

   public void setSelected(boolean selected) {
    this.selected = selected;
  }
  
  public void setSchnittmodus(boolean schnittmodus){
    this.schnittmodus = schnittmodus;
  }
  
  public boolean getSchnittmodus(){
    return schnittmodus;
  }
  //Funktion, die aus den gegebenen Punkten die Strecke erzeugt
  public int yWert(int x1, int y1, int x2, int y2, int x){
    float s1 =  float((y2-y1)*x)/float(x2-x1);
    float s2 =  float(x2*y1-x1*y2)/float(x2-x1);
    float result = s1 + s2;
    return int(result);
 }

 public void setPointP1(Point point){   
    point1 = point;
 }
 
 public void setPointP2(Point point){   
    point2 = point;
 }
 //Für alle abgeleiteten Klasse gültig
 public void setPointP7(Point point){
   point7 = point;
 }
 //Für alle abgeleiteten Klassen gültig
 public Point getP1(){return point1;}
 public Point getP2(){return point2;}
 public Point getP3(){return point3;}
 public Point getP4(){return point4;}
 public Point getP5(){return point5;}
 public Point getP6(){return point6;}
 public Point getP7(){return point7;}
 
 //display-Methode für Strecken
 public void display(){
    point5 = point1;
    point6 = point2;
    y7= yWert(point1.getX(),point1.getY(),point2.getX(),point2.getY(),point7.getX());
    point7.setY(round(y7));
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);
    if (selected) {
      stroke(color(150,0,0));
     }  
    line(point5.getX(),point5.getY(),point6.getX(), point6.getY());
    if (selected) {
      stroke(farbe);
    }
  } 
} 