////////////////////////////////////////////////////////////////////
//Abgeleitet von Line - aber definiert durch zwei Punkte,
//die nicht auf der Mittelsenkrechten liegen!
///////////////////////////////////////////////////////

public class StraightLineMS extends Line {

  public StraightLineMS(Point point3, Point point4) {
    super(point3,point4);
    this.point3 = point3; x3=point3.getX(); y3=point3.getY();
    this.point4 = point4; x4=point4.getX(); y4=point4.getY();  
    y5= funktionsWert34(x3,y3,x4,y4,-10); 
    y6= funktionsWert34(x3,y3,x4, y4, 1010);
    point5 = new Point(-10,round(y5)); point6 = new Point(1010,round(y6));      
    point1 = new Point(round((x3+x4-y4+y3)/2),round((y3+y4+x4-x3)/2));    
    point2 = new Point(round((x3+x4+y4-y3)/2),round((y3+y4-x4+x3)/2));
  }
  
 //Funktion, mit deren Hilfe aus den zwei außerhalb gegebenen Punkten
 //die Mittelsenkrechte definiert werden kann
 int funktionsWert34(int x3, int y3, int x4, int y4, int x){
   float s1 =  float(-(x4-x3)*x)/float(y4-y3);
   float s2 =  float(y4*y4-y3*y3+x4*x4-x3*x3)/float(2*(y4-y3));
   float result = s1 + s2;
   return round(result);
 }  
 //Etwas komplexere display-Methode, weil der rechte Winkel beim
 //verschieben erhalten bleiben muss.
 public void display(){ 
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);
    point7.setY(round(funktionsWert34(point3.getX(), point3.getY(),point4.getX(), point4.getY(), point7.getX())));
    y5= funktionsWert34(point3.getX(),point3.getY(),point4.getX(), point4.getY(),point5.getX());
    y6= funktionsWert34(point3.getX(),point3.getY(),point4.getX(), point4.getY(), point6.getX());
    point5.setY(round(y5)); point6.setY(round(y6));    
    point1.setX(round((point3.getX()+point4.getX()+point3.getY()-point4.getY())/2));  
    point1.setY(round((-point3.getX()+point4.getX()+point3.getY()+point4.getY())/2));  
    point2.setX(round((point3.getX()+point4.getX()-point3.getY()+point4.getY())/2));  
    point2.setY(round((point3.getX()-point4.getX()+point3.getY()+point4.getY())/2));  
    if (selected) {
      stroke(color(150,0,0));       
    }
     
    line(-10,y5,1010, y6);
     
    stroke(color(0));
    }
 
}   