//////////////////////////////////////////////////////////
//Damit kann man kubische BezierCurve-Objekte erzeugen  
//und ihr Verhalten studieren
//////////////////////////////////////////////////////////
public class BezierCurve extends VertexCurve {
  
  //Attribute
  protected boolean selected = false;
  protected boolean schnittmodus = false; 
  private ArrayList<Point> kurvenPunkte= new ArrayList<Point>();
  private int numberOfPoints;
  //Koordinaten der Ankerpunkte auf der Kurve
  private float x1 = 0;
  private float y1 = 0;
  private float x2 = 0;
  private float y2 = 0;
  //Kontrollpunkte
  private float a1 = 0;
  private float b1 = 0;
  private float a2 = 0;
  private float b2 = 0;
  
  public BezierCurve(ArrayList<Point> curvePoints) {
    super(curvePoints);
     numberOfPoints = curvePoints.size();
      for (int i = 0; i < numberOfPoints; i++) {
        kurvenPunkte.add(curvePoints.get(i));
      }
    }
      
  public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point2);
     return abhaengig;  
  }
  
  public boolean getSelected() {
    return selected ;
  }

   public void setSelected(boolean selected) {
    this.selected = selected;
  }
   
 //display-Methode für VertexCurve
 public void display(){
   //fill(255,0,0); //interessante Erweiterung! Ausprobieren!
   x1= kurvenPunkte.get(0).getX(); y1 = kurvenPunkte.get(0).getY();
   a1= kurvenPunkte.get(1).getX(); b1 = kurvenPunkte.get(1).getY();
   a2= kurvenPunkte.get(2).getX(); b2 = kurvenPunkte.get(2).getY();
   x2= kurvenPunkte.get(3).getX(); y2 = kurvenPunkte.get(3).getY();
   strokeWeight(1); stroke(0,0,255);  
   beginShape();
   vertex(x1,y1);
   bezierVertex(a1,b1,a2,b2,x2,y2);
   endShape();
   stroke(0,255,255);
   line(x1,y1,a1,b1);
   line(a2,b2,x2,y2);
 } 
}