//////////////////////////////////////////////////////////////////////////////
//CutObject dient zur Verwaltung zweier (beliebiger) sich schneidender Geraden
//////////////////////////////////////////////////////////////////////////////
private Point point5a = null;
private Point point5b = null;
private Point point6a = null;
private Point point6b = null;

private int xCut, yCut;
//protected boolean selected = false;

public class CutObject extends GeoObject {

  public CutObject (Point point1, Point point2, Point point3, Point point4) {
    super();
    this.point1 = point1;
    this.point2 = point2;
    this.point3 = point3;
    this.point4 = point4;
    point5a = new Point(-10, yWert(point1.getX(), point1.getY(), point2.getX(), point2.getY(), -10));
    point6a = new Point(1010, yWert(point1.getX(), point1.getY(), point2.getX(), point2.getY(), 1010));
    point5b = new Point(-10, yWert(point3.getX(), point3.getY(), point4.getX(), point4.getY(), -10));
    point6b = new Point(1010, yWert(point3.getX(), point3.getY(), point4.getX(), point4.getY(), 1010));
    pCut = berechneSchnittpunkt(point1.getX(), point1.getY(), point2.getX(), point2.getY(), point3.getX(), point3.getY(), point4.getX(), point4.getY());
    geoObjects.add(pCut);  println(pCut.getX() + "   "+pCut.getY());
  }

  public int yWert(int x1, int y1, int x3, int y3, int x) {
    float s1 =  float((y3-y1)*x)/float(x3-x1);
    float s2 =  float(x3*y1-x1*y3)/float(x3-x1);
    float result = s1 + s2;
    return int(result);
  }

  public Point berechneSchnittpunkt(float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4) {
    float m1 =(y2-y1)/(x2-x1);
    float m2 =(y4-y3)/(x4-x3);
    float x = (m1*x1-m2*x3-y1+y3)/(m1-m2) ;
    float y = m1*x - m1*x1 + y1;
    Point p = new Point(int(x), int(y));
    return p;
  }
//Die beiden sich schneidende Geraden gibt es schon unterhalb von Line
//denn die Punkte point1-point7 sind protected und gelten daher in allen 
//Klassen unterhalb GeoObject. Eine weitere Zeichnung line(.....) entfällt daher.
 public void display(){  
  farbe = this.getfarbe();
  stroke(farbe);
  strokeWeight(1);  
  point5a.setY(yWert(point1.getX(),point1.getY(),point2.getX(), point2.getY(),-10));
  point6a.setY(yWert(point1.getX(),point1.getY(),point2.getX(), point2.getY(), 1010));
  point5b.setY(yWert(point3.getX(),point3.getY(),point4.getX(), point4.getY(),-10));
  point6b.setY(yWert(point3.getX(),point3.getY(),point4.getX(), point4.getY(), 1010));
  xCut = berechneSchnittpunkt(point5a.getX(),point5a.getY(),point6a.getX(), point6a.getY(),point5b.getX(),point5b.getY(),point6b.getX(), point6b.getY()).getX();
  yCut = berechneSchnittpunkt(point5a.getX(),point5a.getY(),point6a.getX(), point6a.getY(),point5b.getX(),point5b.getY(),point6b.getX(), point6b.getY()).getY();
  pCut.setX(xCut); pCut.setY(yCut); //pCut.display();
 // line(-10,point5a.getY(),1010, point6a.getY());
 }
}