//////////////////////////////////////////////////////
//Klasse EllipseLine (Ellipse) von CircleLine abgeleitet.
//Ein weiterer Punkt wird benötigt.
//Erster Punkt: Mittelpunkt, zweiter Punkt hat kleineren Abstand zum 
//Mittelpunkt als dritter Punkt.
//////////////////////////////////////////////////////////////
public class EllipseLine extends CircleLine {
  
  //Attribute  
  private Point point3 = null;
  private int  x1, y1, x2, y2, x3, y3 ;
  private float a,b, x21, x31, y21, y31;
 
  //Konstruktor
  public EllipseLine(Point point1, Point point2, Point point3) {
    super(point1, point2);
    this.point1=point1;
    this.point2=point2;
    this.point3=point3;
  }
  
  public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point2 || (p == point3));
     return abhaengig;
  }
 //Überschriebene Methode display()
  public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);
    x1 = point1.getX();y1 = point1.getY();
    x2 = point2.getX();y2 = point2.getY();    
    x3 = point3.getX();y3 = point3.getY(); 
    x21= (x2-x1)*(x2-x1);
    x31= (x3-x1)*(x3-x1);
    y21= (y2-y1)*(y2-y1);
    y31= (y3-y1)*(y3-y1);
    //Halbachsen a und b
    a= (float)Math.sqrt((x31*y21-x21*y31)/(y21-y31));
    b =(float)Math.sqrt(a*a*y21/(a*a-x21));  
    ellipseMode(RADIUS);
    noFill();
    ellipse(x1,y1,a,b);
 } 
 
}