//////////////////////////////////////////////////////////////////////////////
//Paralle zu einer Geraden (repräsentiert durch zwei Punkte) durch einen Punkt
//////////////////////////////////////////////////////////////////////////////
public class ParallelLine extends StraightLineSH{
 
 
  //Dem Konstruktor werden drei Punkte übergeben
  public ParallelLine(Point point1, Point point3, Point point4) {
    super(point1,point3,point4);
    this.point1 = point1;
    this.point3 = point3;
    this.point4 = point4; 
    //Mit den außerhalb der Zeicheneben gelegenen Punkten 5 und 6 wird die Paralle gezeichnet
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(), point4.getX(), point4.getY(),1010);
    point5 = new Point(-10,round(y5)); point6 = new Point(1010,round(y6));  
    
  }
  //Funktion zur Bestimmung aller Punkte auf der Parallen aus den Punkten 1,3 und 4
  int yWert(int x1, int y1, int x2, int y2,  int x3, int y3, int x){
       m =  float((y3-y2))/float((x3-x2));
      float result = m*(x-x1) + y1;
      return round(result);
  }  
  //Methode aus Line muss hier überschrieben werden.
  public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point5 || (p == point6));
     return abhaengig;
  }
 //Methode aus Line muss hier überschrieben werden. 
 public void setPointP1(Point point2){   
    point1 = point2;
 }
//überschriebene display-Methode, die die Benutzereingaben zeichnerisch umsetzt.
 public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);  
    point7.setY(round(yWert(point1.getX(), point1.getY(), point2.getX(), point2.getY(), point7.getX())));
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    point5.setX(-10); point5.setY(round(y5));      
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(), point4.getX(), point4.getY(),1010);
    point6.setX(1010); point6.setY(round(y6));
    if (selected) {
      stroke(color(150,0,0));
    }

    line(-10,y5,1010, y6);
    
   if (selected) {
   stroke(farbe);
   }
  } 
} 