//////////////////////////////////////////////////////////////////////////////
//Lot auf eine Geraden (repräsentiert durch zwei Punkte) durch einen Punkt
//////////////////////////////////////////////////////////////////////////////
public class PerpendicularLine extends StraightLineSH{

  //Dem Konstruktor werden drei Punkte übergeben
  public PerpendicularLine(Point point1, Point point3, Point point4) {
    super(point1,point3,point4);
    this.point1 = point1;
    this.point3 = point3;
    this.point4 = point4;
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),1010);
    point5 = new Point(-10,round(y5)); point6 = new Point(1010,round(y6));  
    
  }
  //Funktion zur Bestimmung aller Punkte des Lots durch Punkt 1 aus den Punkten 1,3 und 4
  int yWert(int x1, int y1, int x2, int y2,  int x3, int y3, int x){
    m =   float(x2-x3)/float((y3-y2));
    float result = m*(x-x1) + y1;
    return int(result);
  }  
 //überschriebene display-Methode, die die Benutzereingaben zeichnerisch umsetzt.
  public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);    
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    point5.setX(-10); point5.setY(round(y5));   
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),1010);
    point6.setX(1010); point6.setY(round(y6));
    if (selected) {
      stroke(color(150,0,0));
    }
   
    line(-10,y5,1010, y6);
  
    if (selected) {
      stroke(farbe);
    }  
  } 
}