///////////////////////////////////////////////////////////
//Seitenhalbierende durch drei Punkte definiert.
////////////////////////////////////////////////////////////
public class StraightLineSH extends Line {
 
  public StraightLineSH(Point point1, Point point3, Point point4) {
    super(point1,point3);
    this.point1 = point1;
    this.point3 = point3;
    this.point4 = point4;
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),1010);
    point5 = new Point(-10,round(y5)); point6 = new Point(1010,round(y6));  
  }

public boolean abhaengigVon (GeoObject p) {
     boolean abhaengig = (p == point1) || (p == point2 || (p == point3));
     return abhaengig;
  }
//Funktion, die aus den drei gegebenen Punkten alle y-Werte auf der Seitenhalbierenden berechnet
int yWert(int x1, int y1, int x3, int y3,  int x4, int y4, int x){
  float s1 =  float((-2*y1+y3+y4)*x)/float(-2*x1+x3+x4);
  float s2 =  float(-x1*y3+x3*y1+x4*y1-x1*y4)/float(-2*x1+x3+x4);
  float result = s1 + s2;
  return int(result);
}  

public void display(){
    farbe = this.getfarbe();
    stroke(farbe);
    strokeWeight(1);
    //point7 ist wieder als weiterer Punkt auf der Seitenhalbierenden konzipiert (Taste "b")
    point7.setY(round(yWert(point1.getX(), point1.getY(), point3.getX(), point3.getY(),point4.getX(), point4.getY(), point7.getX())));
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    point5.setX(-10); point5.setY(round(y5));      
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(), point4.getX(), point4.getY(),1010);
    point6.setX(1010); point6.setY(round(y6));
    if (selected) {
      stroke(color(150,0,0));
    }
    
      line(-10,y5,1010, y6);
  
    y5= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(),point4.getX(), point4.getY(),-10);
    point5.setX(-10); point5.setY(round(y5));      
    y6= yWert(point1.getX(),point1.getY(),point3.getX(), point3.getY(), point4.getX(), point4.getY(),1010);
    point6.setX(1010); point6.setY(round(y6));
    if (selected) {
     stroke(farbe);
    }
  } 
}